// These functions are adapted from Sentido:
// http://www.matracas.org/sentido/
// Sentido is distributed under the General Public Licence, version 2 or,
// at your option, any later version.
// See the project web site for details.

var formula_editor;
formula_editor = null;
var transformer;
transformer = null;
var formula_omobj;
formula_omobj = null;

var message;

var plugin_url;

if ("tinyMCEPopup" in window)
  {
    tinyMCEPopup.requireLangPack = function() {
      var u = this.getWindowArg('plugin_url') || this.getWindowArg('theme_url');
      if (u && this.editor.settings.language) {
	u += '/langs/' + this.editor.settings.language + '_dlg.js';
@!# Use ScriptLoader.add(u), ScriptLoader.loadScripts() if loading more than one.
	tinymce.ScriptLoader.load(u);
      }
    };
    tinyMCEPopup.requireLangPack();

    message = window.parent.message;
    formula_editor = window.parent.formula_editor;
    plugin_url = tinyMCEPopup.getWindowArg('plugin_url');
  }
else
  {
    message = alert;
    plugin_url = tinymce.baseURL + '/plugins/sentido';
  }

var ed;

// Define standard functions for defective browsers like IE 5:
if (! Array.prototype.push)
  {
    Array.prototype.push = function()
      {
        for (var i in arguments) this[this.length] = arguments[i];

        return this.length;
      };
  }

var previous_input;
function input_changed(input)
{
  if (input.value != previous_input)
    {
      previous_input = input.value;
      formula_editor.linear_to_openmath(input.value);
      put_formula_in_title(input.value);
    }
}

var formula_search_variables;
formula_search_variables = { free:{}, bound:{} };
var formula_search_variables_header;
function formula_changed(omobj)
{
  // This code is copied from Sentido, and modified a bit afterwards to
  // account for the small differences in the UI: XUL vs. HTML.
  var formula_display;
  formula_display = document.getElementById("formula-display-mathml");
  if (formula_display)
    {
      var node;
      node = transformer.transformToFragment(omobj, document);
      node = node.firstChild;
      while (node && node.nodeType != Node.ELEMENT_NODE)
        {
          node = node.nextSibling;
        }
      if (node.firstChild && "math" == node.firstChild.localName)
        {
          // There is a span element around the math element.
          node.firstChild.setAttribute("mode", "display");
        }
      formula_display.replaceChild(node, formula_display.firstChild);
    }

  formula_omobj = omobj;

  var variable_types_tbody;
  variable_types_tbody = document.getElementById("formula-search-variable-types");
  var variables;
  variables = formula_editor.get_variables();
  var i;
  for (i = variable_types_tbody.childNodes.length; i > 2; --i)
    {
      variable_types_tbody.removeChild(variable_types_tbody.lastChild);
    }

  var variable_name;
  var variable_row;
  var previous_variable_row;
  var row_item;
  var input;

  previous_variable_row = null;
  for (i in variables.free)
    {
      variable_name = variables.free[i].getAttribute("name");
      variable_row = formula_search_variables.free[variable_name];
      if (!variable_row)
        {
          variable_row = document.createElement("tr");
          variable_row.setAttribute("class", "symbol-row");
          variable_row.generic  = false;
          variable_row.anycount = false;

          row_item = document.createElement("th");
          row_item.appendChild(document.createTextNode(variable_name));
          variable_row.appendChild(row_item);

          row_item = document.createElement("th");
          input = document.createElement("input");
          input.setAttribute("type", "checkbox");
          input.setAttribute("name", "formula-search-free-variable-generic-" + variable_name);
          input.setAttribute("onchange", "formula_search_variable_event(event)");
          row_item.appendChild(input);
          variable_row.appendChild(row_item);

          row_item = document.createElement("th");
          input = document.createElement("input");
          input.setAttribute("type", "checkbox");
          input.setAttribute("name", "formula-search-free-variable-anycount-" + variable_name);
          input.setAttribute("onchange", "formula_search_variable_event(event)");
          row_item.appendChild(input);
          variable_row.appendChild(row_item);

          row_item = document.createElement("th");
          input = document.createElement("input");
          input.setAttribute("type", "checkbox");
          input.setAttribute("name", "formula-search-free-variable-function-" + variable_name);
          input.setAttribute("onchange", "formula_search_variable_event(event)");
          row_item.appendChild(input);
          variable_row.appendChild(row_item);

          formula_search_variables.free[variable_name] = variable_row;
        }

      variable_types_tbody.insertBefore(variable_row, previous_variable_row);
      previous_variable_row = variable_row;
    }
  var separator;
  variable_row = document.createElement("tr");
  variable_row.setAttribute("class", "symbol-row");
  row_item = document.createElement("th");
  row_item.setAttribute("colspan", "4");
  separator = document.createElement("hr");
  separator.setAttribute("style", "padding:0; margin:0");
  row_item.appendChild(separator);
  variable_row.appendChild(row_item);
  variable_types_tbody.appendChild(variable_row);
  previous_variable_row = null;
  for (i in variables.bound)
    {
      variable_name = variables.bound[i].getAttribute("name");
      variable_row = formula_search_variables.bound[variable_name];
      if (!variable_row)
        {
          variable_row = document.createElement("tr");
          variable_row.setAttribute("class", "symbol-row");
          variable_row.generic  = true;
          variable_row.anycount = false;

          row_item = document.createElement("th");
          row_item.appendChild(document.createTextNode(variable_name));
          variable_row.appendChild(row_item);

          row_item = document.createElement("th");
          input = document.createElement("input");
          input.setAttribute("type", "checkbox");
          input.setAttribute("checked", "checked");
          input.setAttribute("name", "formula-search-bound-variable-generic-" + variable_name);
          input.setAttribute("onchange", "formula_search_variable_event(event)");
          row_item.appendChild(input);
          variable_row.appendChild(row_item);

          row_item = document.createElement("th");
          input = document.createElement("input");
          input.setAttribute("type", "checkbox");
          input.setAttribute("name", "formula-search-bound-variable-anycount-" + variable_name);
          input.setAttribute("onchange", "formula_search_variable_event(event)");
          row_item.appendChild(input);
          variable_row.appendChild(row_item);

          row_item = document.createElement("th");
          input = document.createElement("input");
          input.setAttribute("type", "checkbox");
          input.setAttribute("name", "formula-search-bound-variable-function-" + variable_name);
          input.setAttribute("onchange", "formula_search_variable_event(event)");
          row_item.appendChild(input);
          variable_row.appendChild(row_item);

          formula_search_variables.bound[variable_name] = variable_row;
        }

      variable_types_tbody.insertBefore(variable_row, previous_variable_row);
      previous_variable_row = variable_row;
    }
}

function formula_search_variable_event(event)
{
  var name;
  name = event.target.getAttribute("name");
  var property;
  property = name.replace(/.*-([^-]*)-[^-]*$/, "$1");
  var variable_name;
  variable_name = name.replace(/.*-([^-]*)$/, "$1");
  var value;
  value = event.target.checked;
  var variable_row;
  variable_row = event.target.parentNode.parentNode;

  switch (property)
    {
    case "generic":
      if (value) variable_row.generic = true;
      else       variable_row.generic = false;
      break;
    case "anycount":
      if (value) variable_row.anycount = true;
      else       variable_row.anycount = false;
      break;
    case "function":
      if (value) formula_editor.declare_variable(variable_name, "morphism");
      else       formula_editor.declare_variable(variable_name, "object");
      break;
    default:
      message("Error: property="+property+", name="+name);
    }
}

function init()
{
  if ("tinyMCEPopup" in window)
    {
      ed = tinyMCEPopup.editor;
      tinyMCEPopup.resizeToInnerSize();
    }
  else
    {
      ed = window.tinyMCE.activeEditor;
    }

  var f, fe;
  f = document.forms[0];
  fe = find_expression_root(ed.selection.getNode());
  if (/mceItemSentido/.test(ed.dom.getAttrib(fe, 'class'))) {
    if (fe.hasAttribute("linear")) f.formula.value = fe.getAttribute("linear");
    else                           f.formula.value = fe.textContent;
    var options;
    options = f.syntax.options;
    for (var i = 0; i < options.length; ++i)
    {
      if ("x-qmath-" + options[i].value == fe.lang)
	{
	  f.syntax.selectedIndex = i;
	  break;
	}
    }
  }
  TinyMCE_EditableSelects.init();

  var input_text_field;
  input_text_field = document.getElementById('sentido-embedded-input-editor-textarea');

  if (!formula_editor)
    {
      formula_editor = new Formula_editor(input_text_field);
      //formula_editor.init("sentido", "sentido/contexts");
      formula_editor.init(plugin_url + "/sentido", plugin_url + "/sentido/contexts");
      formula_editor.onchange = formula_changed;
      formula_editor.enable_edit(true);
    }
  formula_editor.change_to_context(document.getElementById('sentido-embedded-input-editor-syntax').value);
  if (!transformer)
    {
      transformer = build_transformer(plugin_url + "/sentido/om_to_pmml.xsl");
    }

  if (input_text_field.value) formula_editor.linear_to_openmath(input_text_field.value);

  input_text_field.focus();
}

function find_expression_root(fe)
{
  while (fe.parentNode && /mceItemSentido/.test(ed.dom.getAttrib(fe.parentNode, 'class'))) fe = fe.parentNode;
  
  return fe;
}

function is_alone_in_paragraph(fe)
{
  var is_alone_in_paragraph = (fe.parentNode.nodeName.toLowerCase() == "p"
                               && !fe.previousSiblingElement);
  var n = fe.nextSibling;
  while (n && is_alone_in_paragraph) {
    if (n.nodeName.toLowerCase() != "br") is_alone_in_paragraph = false;
    n = n.nextSibling;
  }
  
  return is_alone_in_paragraph;
}

function put_formula_in_title(linear_formula)
{
  if ("undefined" == typeof linear_formula)
    {
      linear_formula = document.getElementById("sentido-embedded-input-editor-textarea").value;
    }
  document.title = linear_formula;
}

function toggle_palette(palette_item)
{
  var palette_table = palette_item;
  while (palette_table.parentNode && palette_table.localName != 'table') palette_table = palette_table.parentNode;
  var class_name = 'symbol-palette';
  if (class_name == palette_table.getAttribute('class')) class_name = 'symbol-palette-folded';
  palette_table.setAttribute('class', class_name);
}

var message_count;
message_count = 0;
function message(text)
{
  // Avoid annoying the user if we get a cascade of error messages.
  if (++message_count < 10) alert(text);
}

var sentido =
  {
    serializer: new XMLSerializer(),
    parser: new DOMParser(),
    getSerializedXmlFormula: function ()
    {
      if (false)
      {
	var variables;
	variables = formula_editor.get_variables();
	var variable;
	var variable_name;
	var variable_row;
	var i;

	for (i in variables.free)
        {
          variable = variables.free[i];
          variable_name = variable.getAttribute("name");
          variable_row = formula_search_variables.free[variable_name];
          if (variable_row.generic)
          {
            variable.setAttribute("mq:generic", variable_name);
          }
          else
          {
            variable.removeAttribute("mq:generic");
          }
          if (variable_row.anycount)
          {
            variable.setAttribute("mq:anycount", "yes");
          }
          else
          {
            variable.removeAttribute("mq:anycount");
          }
        }
	for (i in variables.bound)
        {
          variable = variables.bound[i];
          variable_name = variable.getAttribute("name");
          variable_row = formula_search_variables.bound[variable_name];
          if (variable_row.generic)
          {
            variable.setAttribute("mq:generic", variable_name);
          }
          else
          {
            variable.removeAttribute("mq:generic");
          }
          if (variable_row.anycount)
          {
            variable.setAttribute("mq:anycount", "yes");
          }
          else
          {
            variable.removeAttribute("mq:anycount");
          }
        }

	formula_omobj.setAttribute("xmlns:mq", "http://mathweb.org/MathQuery");
      }

      var query = formula_omobj;

      if (false) // This is used only for MathWebSearch.
      {
	om_to_cmml_translator = build_transformer(plugin_url + "/sentido/om_to_cmml.xsl");

	query = om_to_cmml_translator.transformToFragment(query, query.ownerDocument);
      }

      return this.serializer.serializeToString(query);
    },
    setSerializedXmlFormula: function (serialized_XML_formula)
    {
      var xml_document;
      xml_document = this.parser.parseFromString(serialized_XML_formula, "text/xml");
      if ("OMOBJ" == xml_document.documentElement.localName)
        {
          formula_omobj = xml_document.documentElement;
          formula_editor.select_node(formula_omobj);
        }
    }
  };

function setChildrenClassAttributesFromParent(node) {
  var child = node.firstChild;
  while (child) {
    if (child.nodeType == child.ELEMENT_NODE) {
      child.setAttribute('class', node.getAttribute('class'));
      setChildrenClassAttributesFromParent(child);
    }
    child = child.nextSibling;
  }
}
function setHidden(node) {
  node.className = 'mceItemHidden';
  node = node.firstChild;
  while (node) {
    if (node.nodeType==1) setHidden(node);
    node = node.nextSibling;
  }
}

function insertSentido() {
  var fe, f = document.forms[0], h;

  tinyMCEPopup.restoreSelection();

  if (!AutoValidator.validate(f)) {
    alert(ed.getLang('invalid_data'));
    return false;
  }

  var formula_title, formula_syntax, formula_presentation, formula_content;
  formula_presentation = f.formula.value;
  formula_content = sentido.getSerializedXmlFormula();
  formula_syntax = f.syntax.options[f.syntax.selectedIndex].value;
  formula_title = formula_syntax + ": " + formula_presentation;
  var formula_display, formula_mathml;
  formula_display = document.getElementById("formula-display-mathml");
  formula_mathml = sentido.serializer.serializeToString(formula_display.firstChild.firstChild);
  formula_language = "x-qmath-" + formula_syntax;

  fe = ed.selection.getNode();
@!put_OM_and_MathML_in_attributes = 1
  if (fe == null || !/mceItemSentido/.test(ed.dom.getAttrib(fe, 'class'))) {
    h = '<span class="mceItemSentido" id="sentido-last-inserted-formula">math</span>' ;
    ed.execCommand('mceInsertContent', false, h);
    // Quite excessive, but doing it with the selection doesn't work because
    // we get the parent node, not the last inserted one.
    //fe = ed.selection.getStart();
    fe = ed.dom.get("sentido-last-inserted-formula");
    fe.removeAttribute("id");
  }
  fe = find_expression_root(fe);
  if (is_alone_in_paragraph(fe)) {
    var parent = fe.parentNode;
    parent.removeChild(fe);
    parent = parent.parentNode.insertBefore(parent.cloneNode(false), parent);
    while (fe.firstChild) parent.appendChild(fe.firstChild);
    parent.setAttribute("class", fe.getAttribute("class"));
    fe = parent;
  }
  
  fe.setAttribute("title", formula_title);
  fe.textContent = "";// Empty the element
  fe.setAttribute("lang", formula_language);
@!if put_OM_and_MathML_in_attributes:
@'  '  fe.setAttribute("openmath", formula_content);
@'  '  fe.setAttribute("mathml", formula_mathml);
  fe.setAttribute("linear", formula_presentation);
  
  //ed.execCommand('mceRepaint');
  var insert_mathml = true;
  if (insert_mathml) {
    formula_mathml = document.importNode(formula_display.firstChild, true);
    if (formula_mathml && formula_mathml.localName === "span") formula_mathml = formula_mathml.firstElementChild;// This is always the case in the current version
    if (formula_mathml) {
      if ('p' == fe.localName.toLowerCase()) {
        formula_mathml.setAttribute('mode', 'display');
      } else {
        formula_mathml.removeAttribute('mode');
      }
      fe.appendChild(formula_mathml);
      setChildrenClassAttributesFromParent(fe);
      //setHidden(fe.lastChild);
    }
  }
  else {
    fe.textContent = formula_presentation;
  }
  
  tinyMCEPopup.close();
}

if ("tinyMCEPopup" in window) tinyMCEPopup.onInit.add(init);

@!<"../../../mathwebsearch/include.xslt_utils.js"
@!<"/svn/trunk/sentido.xpi.d/chrome/content/lib/parser/Parser.js"
@!<"/svn/trunk/sentido.xpi.d/chrome/content/lib/parser/QMath.js"
@!<"/svn/trunk/sentido.xpi.d/chrome/content/views/Formula_editor/Formula_editor.js"
